# coding=utf-8
""" converthk.py for AP90
 Reads/Writes utf-8
 Oct 18, 2014:  Take care of 'junk' in {#..#} to preserve invertibility
  Use local copy of hk_slp1.xml and slp1_hk.xml 
"""
import sys, re,codecs
sys.path.insert(0,"../")  # where transcoder resides

import transcoder
transcoder.transcoder_set_dir(""); # use local non-standard transcoder files

def unused_dbgout(fout,s):
 if fout:
  fout.write("%s\n" % s)

def convert(filein,fileout,tranin,tranout):
 # slurp txt file into list of lines
 with codecs.open(filein,encoding='utf-8',mode='r') as f:
    inlines = f.readlines()
 fout = codecs.open(fileout,'w','utf-8')
 nchg=0
 mlines = len(inlines)
 if False: # dbg
  mlines = min(1000,mlines)
  print "DEBUG %s lines" %mlines
 insan = False
 for i in xrange(0,mlines):
  line=inlines[i].rstrip('\r\n')
  if tranin == 'hk':
   line = re.sub(r'{#{@','{@{#',line)
   line = re.sub(r'@}#}','#}@}',line)
   partsrebase = r'([.]#})|({#)|(#})|(<>)|(\[Page.*?\])'
  else:  # 'slp1'
   line = line.replace('#}.]','#}.{#]#}')
   line = line.replace(r'#}@}{#','@}')
   line = line.replace(r'#}{@{#','{@')
   #partsrebase = r'(#}@}{#)|(#}[.]{#)|(#}[.])|({#)|(#})|(<>)|(\[Page.*?\])'
   partsrebase = r'(#}[.]{#)|(#}[.])|({#)|(#})|(<>)|(\[Page.*?\])'
  partsreByLine = r'(^[0-9]+ old )|(^[0-9]+ new )'
  partsre = "%s|%s" % (partsrebase,partsreByLine)
  parts = re.split(partsre,line)
  nparts = len(parts)
  outparts = []
  for ipart in xrange(0,nparts):
   part = parts[ipart]
   if not part:  # peculiarity of split, some empty parts returned
    continue
   if re.search(partsreByLine,part):  
    # for manualByline, etc.
    insan = False
    outparts.append(part)
   elif part == '.#}': # hk
    insan = False
    outparts.append('#}.')
   elif part == '#}.': # slp1
    insan = False
    outparts.append('.#}')
   elif part == '{#':
    insan = True
    outparts.append(part)
   elif part == '#}':
    outparts.append(part)
    insan=False
   elif part == '#}.{#':
    insan=True
    outparts.append('.')
   #elif part == '#}@}{#':
   # insan=True
   # outparts.append('@}')
   elif part == '<>':
    outparts.append(part)
   elif part.startswith('[Page'):
    outparts.append(part)
   elif re.search(partsreByLine,part):
    outparts.append(part)
   elif insan:
    partout = transcoder.transcoder_processString(part,tranin,tranout)
    outparts.append(partout)
   else:
    outparts.append(part)
  #print outparts.encode('utf-8')
  out = ''.join(outparts)
  if tranin == 'hk':
   out = out.replace(r'#}.{#]#}','#}.]')
  if tranin == 'slp1':
   out = re.sub(r'{@{#',r'{#{@',out)
   out = re.sub(r'#}@}',r'@}#}',out)
   out = re.sub(r'\[{#([^#]*?)[.] ([^#]*?)[.]\]#}',r'[{#\1. \2.#}]',out)
   out = out.replace(r'#}[{#','[')
  fout.write('%s\n' % out)
 fout.close()

if __name__=="__main__":
 option = sys.argv[1]
 filein = sys.argv[2] # 
 fileout = sys.argv[3] #
 if option == '1':
  convert(filein,fileout,'hk','slp1')
 elif option == '2':
  convert(filein,fileout,'slp1','hk')
 else:
  print "Bad option = ",option
  print "option must be 1 or 2"

