"""hw1.py  
 Read  hw0.txt
 
 'Normalize' all headword spellings.
 Then output the same format, using the normalized headword
 See headword.py for the normalization details  (see hw_normalize0)
  Aug 12, 2014.  Modify since words now in slp1.
  Nov 20, 2014. (nukta codes already removed)
  Nov 22, 2014.  Prefer one particular parenthesized form as key1.
"""
import sys,re,codecs
from headword import dictParms
def hw_normalize0(hw,parms):
 if 'hw1_special' in parms:
  special_cases = parms['hw1_special']
 else:
  special_cases = {}
 if 'hw1_norm' in parms:
  norm_cases = parms['hw1_norm']
 else:
  norm_cases = []

 if hw in special_cases:
  hw1 = special_cases[hw]
  print "Special case: %s -> %s" %(hw,hw1)
  return hw1 
 hw0 = hw

 for (old,new) in norm_cases:
  hw = re.sub(old,new,hw)
 return hw

def hw_normalize(hw,parms):
 hw0 = hw
 hw = hw_normalize0(hw,parms)
 m = re.search(r'([^a-zA-Z])',hw)
 if m:
  c = m.group(1)
  cint = ord(c)
  print "headword '%s' (%s) has unexpected character '%s' = %s" %(hw,hw0,c,cint)
 return hw

if __name__ == "__main__":
 filein=sys.argv[1] 
 fileout =sys.argv[2] 
 filenote =sys.argv[3]
 # deduce dictionary code from filein
 m = re.search(r'([a-z0-9]+)hw0[.]txt$',filein)
 if not m:
  print "Error parsing filein:",filein
  exit(1)
 dictlo = m.group(1)
 #print "dictlo=",dictlo
 parms = dictParms[dictlo]
 f = codecs.open(filein,'r','utf-8')
 fout = codecs.open(fileout,'w','utf-8')
 fnote = codecs.open(filenote,'w','utf-8')
 n = 0
 nnote = 0
 nout = 0 # number of headword lines written to output
 for line in f:
  n = n+1
  line = line.strip() # remove starting or ending whitespace
  (pagecol,hw0,line12) = re.split(':',line)
 
  hw = hw_normalize(hw0,parms)
  out = "%s:%s:%s" %(pagecol,hw,line12)
  fout.write("%s\n" % out);
  nout = nout + 1
  if ((hw != hw0) and ((hw+"-")!=hw0)):
   out = "%s:  '%s' => '%s'  :%s" %(pagecol,hw0,hw,line12)
   fnote.write("%s\n" % out);
   nnote = nnote + 1
 f.close()
 fout.close()
 fnote.close()
 print "file %s has %s lines" % (filein,n)
 print "%s headwords written to file %s" % (nout,fileout)
 print "%s headwords with normalization changes written to %s" % (nnote,filenote)
 
